import { Runtime, Integrations, SubController, globalBind, LogCodeManager, defineConfig, } from './internal';
export class Agile {
    constructor(config = {}) {
        config = defineConfig(config, {
            localStorage: false,
            waitForMount: true,
            bindGlobal: false,
            autoIntegrate: true,
            bucket: true,
        });
        this.config = {
            waitForMount: config.waitForMount,
            bucket: config.bucket,
        };
        this.key = config.key;
        this.integrations = new Integrations(this, {
            autoIntegrate: config.autoIntegrate,
        });
        this.runtime = new Runtime(this);
        this.subController = new SubController(this);
        LogCodeManager.log('10:00:00', [], this);
        if (config.bindGlobal)
            if (!globalBind(Agile.globalKey, this)) {
                LogCodeManager.log('10:02:00');
            }
    }
    integrate(integration) {
        this.integrations.integrate(integration);
        return this;
    }
    hasIntegration() {
        return this.integrations.hasIntegration();
    }
}
Agile.globalKey = '__agile__';
