import { Computed, defineConfig, removeProperties, shared, } from '../internal';
export * from './computed';
export function createComputed(computeFunction, configOrDeps) {
    let _config = {};
    if (Array.isArray(configOrDeps)) {
        _config = defineConfig(_config, {
            computedDeps: configOrDeps,
        });
    }
    else {
        if (configOrDeps)
            _config = configOrDeps;
    }
    _config = defineConfig(_config, { agileInstance: shared });
    return new Computed(_config.agileInstance, computeFunction, removeProperties(_config, ['agileInstance']));
}
