import { Storage, Storages, shared, defineConfig, removeProperties, LogCodeManager, runsOnServer, } from '../internal';
export * from './storages';
let storageManager = null;
export function createStorage(config) {
    return new Storage(config);
}
export function createStorageManager(config = {}) {
    config = defineConfig(config, {
        agileInstance: shared,
    });
    return new Storages(config.agileInstance, removeProperties(config, ['agileInstance']));
}
export function getStorageManager() {
    if (storageManager == null) {
        const newStorageManager = createStorageManager({
            localStorage: !runsOnServer(),
        });
        assignSharedAgileStorageManager(newStorageManager);
        return newStorageManager;
    }
    return storageManager;
}
export const assignSharedAgileStorageManager = (instance) => {
    if (storageManager != null) {
        LogCodeManager.log('11:02:06', [], storageManager);
    }
    storageManager = instance;
};
