import { Agile } from './internal';
/**
 * Shared Agile Instance that is used when no Agile Instance was specified.
 */
declare let sharedAgileInstance: Agile;
export { sharedAgileInstance as shared };
/**
 * Assigns the specified Agile Instance as the shared Agile Instance.
 *
 * @param agileInstance - Agile Instance to become the new shared Agile Instance.
 */
export declare function assignSharedAgileInstance(agileInstance: Agile): void;
export interface CreateAgileSubInstanceInterface {
    /**
     * Instance of Agile the Instance belongs to.
     * @default sharedAgileInstance
     */
    agileInstance?: Agile;
}
